/*
 * @Author: linminghui linminghui@cloudwalk.com
 * @Date: 2024-05-26 12:02:57
 * @LastEditors: lmh
 * @LastEditTime: 2024-05-30 12:06:54
 * @FilePath: /鼠标应用/ai-h5/src/views/calm-reading/components/utils/types.d.ts
 * @Description: 类型
 */


declare enum IDomEnum {
  ALL = 'whole',
  VIRTUAL = 'virtual',
  SCROLL = 'scroll'
}
type IOptions = {
  container: HTMLElement;
  url: string;
  style?: Partial<IStyle>;
  domMethod?: IDomEnum
  initCallback?: Function
  pdfStateCallback?: Function
}
type IStyle = {
  fill: string;
  stroke: string;
  strokeWidth: string;
  width: string;
  height: string;
}
interface IPDFViewer {
  container: HTMLElement | null;
  setHighlight(chunk_bboxes: ILabelState[]): void;
  get pageState(): IPdfState;
  set pageState(newState: IPdfState);
  destroy(): void;
  prePage(): void;
  jumpPage(num: number): void;
  nextPage(): void;
}
type IPdfState = {
  pageNum: number; // 当前页面
  scale: number; // 缩放比例
  numPages: number; // 总页数
  width: number; // pdf宽度
  height: number; // pdf高度
}

type IChunkBox = number[]

type ILabelState = {
  page: number;
  bbox: IChunkBox
}

declare class PDFViewer implements IPDFViewer {
    private options;
    container: HTMLElement | null;
    scrollList: HTMLElement | null;
    private url;
    private pdfDocument;
    private pdfState;
    private style;
    private domMethod;
    private dataSource;
    private renderData;
    private maxCount;
    private startIndex;
    private endIndex;
    private pointerIndex;
    private isPageChange;
    constructor(options: IOptions);
    private insertScript;
    private init;
    destroy(): void;
    private loadFile;
    private renderPage;
    private ComputePointerPosition;
    private GetRenderData;
    private Render;
    private scrollIntoView;
    private handleContainerScroll;
    private scrollToCurr;
    private clearPdfPageSvg;
    private createPdfPageSvg;
    private groupByPage;
    setHighlight(chunk_bboxes: ILabelState[]): void;
    get pageState(): IPdfState;
    set pageState(newState: IPdfState);
    prePage(): void;
    jumpPage(num: number): void;
    nextPage(): void;
}

export { PDFViewer as default };
