/*
 * @Author: linminghui linminghui@cloudwalk.com
 * @Date: 2024-05-26 12:02:57
 * @LastEditors: lmh
 * @LastEditTime: 2024-05-30 12:06:54
 * @FilePath: /鼠标应用/ai-h5/src/views/calm-reading/components/utils/types.d.ts
 * @Description: 类型
 */
export type { PDFDocumentProxy, PDFPageProxy } from 'pdfjs-dist/types/src/pdf'

export enum IDomEnum {
  ALL = 'whole',
  VIRTUAL = 'virtual',
  SCROLL = 'scroll'
}
export type IOptions = {
  container: HTMLElement;
  url: string;
  style?: Partial<IStyle>;
  domMethod?: IDomEnum
  initCallback?: Function
  pdfStateCallback?: Function
}
export type IStyle = {
  fill: string;
  stroke: string;
  strokeWidth: string;
  width: string;
  height: string;
}
export interface IPDFViewer {
  container: HTMLElement | null;
  setHighlight(chunk_bboxes: ILabelState[]): void;
  get pageState(): IPdfState;
  set pageState(newState: IPdfState);
  destroy(): void;
  prePage(): void;
  jumpPage(num: number): void;
  nextPage(): void;
}
export type IPdfState = {
  pageNum: number; // 当前页面
  scale: number; // 缩放比例
  numPages: number; // 总页数
  width: number; // pdf宽度
  height: number; // pdf高度
}

export interface CustomCanvasRenderingContext2D extends CanvasRenderingContext2D {
  webkitBackingStorePixelRatio?: number;
  mozBackingStorePixelRatio?: number;
  msBackingStorePixelRatio?: number;
  oBackingStorePixelRatio?: number;
  backingStorePixelRatio?: number;
}

export type IChunkBox = number[]

export type ILabelState = {
  page: number;
  bbox: IChunkBox
}

export type IChunkBoxes = {
  page: number;
  bboxes: IChunkBox[]
}
export interface IItemPanel {
  page: number;
  item: HTMLDivElement
}
